#ifndef __MAIN_H__
#define __MAIN_H__

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <fcntl.h>
#include <pthread.h>
#include <unistd.h>
#include <termios.h>
#include "gpio_pwm.h"
#include "main.h"
#include "ip.h"
#include "mqtt.h"
#include "delay.h"
#include "opensh.h"
#include "INA226.h"

#define filename "/home/orangepi/car/master/Deviceld.txt"
pthread_t thread[4];


//开启线程
int thread_start(void *AppExit(void *arg),void *Mqttbeat(void *arg),void *opensh(void *arg),void *Mqtt_onnect(void *arg))
{
    

    if(pthread_create(&thread[0],NULL,AppExit,NULL)!=0)
    {
        perror("Failed to create thread 0");
        return 0;
    }

    if(pthread_create(&thread[1],NULL,Mqttbeat,NULL)!=0)
    {
        perror("Failed to create thread 1");
        return 1;
    }


     if(pthread_create(&thread[2],NULL,opensh,NULL)!=0)
    {
        perror("Failed to create thread 2");
        return 2;
    }
     if(pthread_create(&thread[3],NULL,Mqtt_onnect,NULL)!=0)
    {
        perror("Failed to create thread 3");
        return 3;
    }

    return 0;
}

// 等待线程结束
void thread_end()
{

    pthread_join(thread[0], NULL);

    pthread_join(thread[1], NULL);

    pthread_join(thread[2], NULL);

    pthread_join(thread[3], NULL);
    
}

#endif